//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1  DeepSkyBlue
#property indicator_color2  DimGray
#property indicator_color3  PaleVioletRed
#property indicator_color4  DeepSkyBlue
#property indicator_color5  DimGray
#property indicator_color6  PaleVioletRed
#property indicator_color7  Silver
#property indicator_color8  Silver
#property indicator_style2  STYLE_DOT
#property indicator_style4  STYLE_DOT
#property indicator_style5  STYLE_DOT
#property indicator_style6  STYLE_DOT
#property indicator_style8  STYLE_DOT
#property indicator_width7  2

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    BandsPrice       = 8;
extern double DeviationsPeriod = 50;
extern int    SwingCount       = 1;
extern double Speed            = 1.0;
extern int    FutureBars       = 100;
extern bool   SkipSunday       = false;
extern bool   Interpolate      = true;
extern bool   alertsOn         = false;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

//
//
//
//
//

double bandup[];
double banddn[];
double bandmi[];
double banfup[];
double banfdn[];
double banfmi[];
double lrvalue[];
double lrforecast[];
double swingBuffer[];
double breakouts[];

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   returnFutureSlope;
bool   calculateValue;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   SetIndexBuffer(0,bandup);
   SetIndexBuffer(1,bandmi);
   SetIndexBuffer(2,banddn);
   SetIndexBuffer(3,banfup);
   SetIndexBuffer(4,banfmi);
   SetIndexBuffer(5,banfdn);
   SetIndexBuffer(6,lrvalue);
   SetIndexBuffer(7,lrforecast);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnFutureSlope = (TimeFrame=="returnFutureSlope"); if (returnFutureSlope) { calculateValue=true; return(0); }
         calculateValue    = (TimeFrame=="calculateValue");    if (calculateValue)                           return(0);
         returnBars        = (TimeFrame=="returnBars");        if (returnBars)                               return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
   
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,k,n,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { bandup[0] = limit+1; return(0); }
         if (ArraySize(breakouts)!=Bars) ArrayResize(breakouts,Bars);

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      if (ArraySize(swingBuffer)!=Bars) ArrayResize(swingBuffer,Bars);
      for(i=limit; i>=0; i--) 
      {
         int swing = 0,d=0;
         if (!isSunday(i,0))
         {
            if (High[i] > High[i+1] && High[i+1] > High[i+2] && Low[i+2] < Low[i+3]  && Low[i+3]  < Low[i+4])  swing = -1;
            if (Low[i]  < Low[i+1]  && Low[i+1]  < Low[i+2]  && High[i+2]> High[i+3] && High[i+3] > High[i+4]) swing =  1;
         }
         swingBuffer[Bars-i-1] = swing;
            for (k=i,n=0; (k<Bars) && (n<SwingCount); k++) { if(swingBuffer[Bars-k-1]!=0) n++; if (isSunday(k,0)) d++; } 
            int BandsPeriod = MathMax(MathRound((k-d-i)/SwingCount/Speed),1);
   
         //
         //
         //
         //
         //
       
         double slope;      
         double linreg    = iLRValue(getPrice(BandsPrice,i),BandsPeriod,i,slope);
         double deviation = iDeviation(linreg,DeviationsPeriod,i);
            lrvalue[i] = linreg;
            if (i>Bars-1)
            {
               bandup[i] = linreg;
               banddn[i] = linreg;
               bandmi[i] = linreg;
               continue;
            }         
         
         //
         //
         //
         //
         //
         
         bandup[i] = bandup[i+1];
         bandmi[i] = bandmi[i+1];
         banddn[i] = banddn[i+1];
         if (linreg>bandup[i+1] || linreg<banddn[i+1])
         {
            bandup[i] = linreg+2.0*deviation;
            banddn[i] = linreg-2.0*deviation;
            bandmi[i] = linreg;
         }
         
         //
         //
         //
         //
         //
         
         if (i==0)
         {
            for (int cross=0; cross<FutureBars; cross++)
            {
               double value = linreg+slope*cross;
                  if (value > bandup[0]) break;
                  if (value < banddn[0]) break;
            }
            for (k=0; k<=cross; k++)
            {
               banfup[cross-k]     = bandup[0];
               banfdn[cross-k]     = banddn[0];
               banfmi[cross-k]     = bandmi[0];
               lrforecast[cross-k] = linreg+slope*k;
            }
         }
         
         //
         //
         //
         //
         //
         
         breakouts[Bars-i-1] = breakouts[Bars-i-2];
            if (lrvalue[i]>bandup[i+1])                           breakouts[Bars-i-1]= 1;
            if (lrvalue[i]<banddn[i+1])                           breakouts[Bars-i-1]=-1;
            if (lrvalue[i]>bandup[i+1] && lrvalue[i]<bandup[i+1]) breakouts[Bars-i-1]= 0;
      }
      
      //
      //
      //
      //
      //
      
      if (!calculateValue)
      {
         SetIndexShift(3,cross); SetIndexDrawBegin(3,Bars-cross-1);
         SetIndexShift(4,cross); SetIndexDrawBegin(4,Bars-cross-1);
         SetIndexShift(5,cross); SetIndexDrawBegin(5,Bars-cross-1);
         SetIndexShift(7,cross); SetIndexDrawBegin(7,Bars-cross-1);
      }
      if (returnFutureSlope) bandup[0]=slope; else manageAlerts();
      return(0);
   }      
 
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         bandup[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsPrice,DeviationsPeriod,SwingCount,Speed,FutureBars,SkipSunday,0,y);
         bandmi[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsPrice,DeviationsPeriod,SwingCount,Speed,FutureBars,SkipSunday,1,y);
         banddn[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsPrice,DeviationsPeriod,SwingCount,Speed,FutureBars,SkipSunday,2,y);
         lrvalue[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsPrice,DeviationsPeriod,SwingCount,Speed,FutureBars,SkipSunday,6,y);
         
            //
            //
            //
            //
            //
            
            int barToCheck = iBarShift(NULL,0,iTime(NULL,timeFrame,y+1));
               breakouts[Bars-i-1] = breakouts[Bars-i-2];
                  if (lrvalue[i]>bandup[barToCheck])                                  breakouts[Bars-i-1]= 1;
                  if (lrvalue[i]<banddn[barToCheck])                                  breakouts[Bars-i-1]=-1;
                  if (lrvalue[i]>bandup[barToCheck] && lrvalue[i]<bandup[barToCheck]) breakouts[Bars-i-1]= 0;
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,timeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
            for(k = 1; k < n; k++)
               lrvalue[i+k]  = lrvalue[i] + (lrvalue[i+n]-lrvalue[i])*k/n;
   }

   //
   //
   //
   //
   //
      
   slope  = iCustom(NULL,timeFrame,indicatorFileName,"returnFutureSlope",BandsPrice,DeviationsPeriod,SwingCount,Speed,FutureBars,SkipSunday,0,0)*Period()/timeFrame;
   linreg = lrvalue[0];
      for (cross=0; cross<FutureBars*timeFrame/Period(); cross++)
      {
         value = linreg+slope*cross;
           if (value > bandup[0]) break;
           if (value < banddn[0]) break;
      }
      for (k=0; k<=cross; k++)
      {
           banfup[cross-k]     = bandup[0];
           banfdn[cross-k]     = banddn[0];
           banfmi[cross-k]     = bandmi[0];
           lrforecast[cross-k] = linreg+slope*k;
      }

   //
   //
   //
   //
   //

   SetIndexShift(3,cross); SetIndexDrawBegin(3,Bars-cross-1);
   SetIndexShift(4,cross); SetIndexDrawBegin(4,Bars-cross-1);
   SetIndexShift(5,cross); SetIndexDrawBegin(5,Bars-cross-1);
   SetIndexShift(7,cross); SetIndexDrawBegin(7,Bars-cross-1);
   manageAlerts();
   return(0);
}


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double getPrice(int type, int i)
{
   switch (type)
   {
      case 7 : return((Open[i]+High[i]+Low[i]+Close[i])/4.0);
      case 8 : return((Open[i]+High[i]+Low[i]+Close[i]+Close[i])/5.0);
      default : return(iMA(NULL,0,1,0,MODE_SMA,MathMax(MathMin(type,6),0),i));
   }
}

//
//
//
//
//

double workDev[];
double iDeviation(double value, double period, int i, bool isSample=false)
{
   if (ArraySize(workDev)!=Bars) ArrayResize(workDev,Bars); int r = Bars-i-1;

   workDev[r] = value; if (r<period) return(0);   
   
   //
   //
   //
   //
   //

   int k,d;
   double avg = 0; for (k=0,d=0; k<period; d++) if (!isSunday(i,d)) { avg += workDev[r-d]; k++; } avg /= period; 
   double sum = 0; for (k=0,d=0; k<period; d++) if (!isSunday(i,d)) { sum += MathPow(workDev[r-d]-avg,2); k++; }
   if (isSample)
         return(MathSqrt(sum/(period-1.0)));
   else  return(MathSqrt(sum/period));
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double workLr[];
double iLRValue(double value, int period, int i, double& slope)
{
   if (ArraySize(workLr)!=Bars) ArrayResize(workLr,Bars); int r = Bars-i-1;
                 workLr[r] = value;
                 if (r<period) return(value);
                 
   //
   //
   //
   //
   //
                    
   double sumX    = period * (period-1) / 2.0;
   double sumXX   = period * (period-1) * (2.0 * period - 1.0) / 6.0;
   double divisor = MathPow(sumX,2.0) - period * sumXX;
   double SumXY   = 0;
   double SumY    = 0;

         int k=0,d=0;
         for (; k<period; d++)
            if (!isSunday(i,d))
               {
                  SumXY += k*workLr[r-d];
                  SumY  +=   workLr[r-d];
                  k++;
               }                  
   
   //
   //
   //
   //
   //
   
   if( divisor != 0 ) 
         	slope = (period * SumXY - sumX * SumY)/divisor;
   else     slope = 0; 
   return((SumY-slope*sumX)/period + slope*(period-1));
}
bool isSunday(int i, int d) { return(SkipSunday && TimeDayOfWeek(Time[i+d])==0); }


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = Bars-iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar))-1;
      
      //
      //
      //
      //
      //
      
      if (breakouts[whichBar] != breakouts[whichBar-1])
      {
         if (breakouts[whichBar] == 1) doAlert(whichBar,"up");
         if (breakouts[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," alb Mogalef bands breakout ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"alb Mogalef bands"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}